/*
 * ProviderEvent.java
 *
 * 作成日: 2008/10/01
 * Copyright(C)2008 Kyushu Institute of Technology., All right reserved. 
 */
package jp.ac.kyutech.SRP.Scripting;

import java.util.EventObject;

/**
 * ProviderのRTコンポーネントからのイベントに使用されるイベントオブジェクトです。
 *
 * @author 
 */
public class ProviderEvent extends EventObject {

    private static final long serialVersionUID = 5796916967777544776L;

    //protected ProviderSupport support;
    
    //protected Object serviceBase;
    
    protected String methodName;
    
    protected Object[] arguments;
    
    /**
     * イベント元を指定してのコンストラクタ。
     * 
     * @param source
     */
    public ProviderEvent(Object source) {
        this(source, "", null);
    }

    /**
     * イベント元と呼び出しメソッド名を指定してのコンストラクタ。
     * 
     * @param source
     * @param methodName
     * @param args
     */
    public ProviderEvent(Object source, String methodName, Object[] args) {
        super(source);
        setMethodName(methodName);
        setArguments(args);
    }
    
    /**
     * @return methodName を戻します。
     */
    public String getMethodName() {
        return methodName;
    }

    /**
     * @param methodName 設定する methodName
     */
    public void setMethodName(String methodName) {
        this.methodName = methodName;
    }

    /**
     * @return arguments を戻します。
     */
    public Object[] getArguments() {
        return arguments;
    }

    /**
     * @param arguments 設定する arguments
     */
    public void setArguments(Object[] arguments) {
        this.arguments = arguments;
    }

    /* (non-Javadoc)
     * @see java.util.EventObject#toString()
     */
    @Override
    public String toString() {
        return new org.apache.commons.lang.builder.ToStringBuilder(this)
            .append("methodName", methodName)
            .append("arguments", java.util.Arrays.toString(arguments)).toString();
    }
    
}
