package jp.go.aist.hrp.simulator;


/**
* jp/go/aist/hrp/simulator/LinkInfoOperations.java .
* IDL-to-Java コンパイラ (ポータブル), バージョン "3.1" で生成
* 生成元: C:/Users/ishimura/workspaces/ai_project/OpenHRP3Client/src/idl/OpenHRP/ModelLoader.idl
* 2009年2月18日 12時58分36秒 JST
*/


/**
   * LinkInfo Interface
   * @author  Ichitaro Kohara, MSTC
   */
public interface LinkInfoOperations 
{

  /**
       * @if jp
       * 位置ベクトル
       * @endif
       */
  double[] translation ();

  /**
       * @if jp
       * 姿勢行列
       * @endif
       */
  double[] rotation ();

  /**
       * @if jp
       * 質量
       * @endif
       */
  double mass ();

  /**
       * @if jp
       * 重心位置
       * @endif
       */
  double[] centerOfMass ();

  /**
       * @if jp
       * 慣性
       * @endif
       */
  double[] inertia ();

  /**
       * @if jp
       * 関節値最大値
       * @endif
       */
  double[] ulimit ();

  /**
       * @if jp
       * 関節値最小値
       * @endif
       */
  double[] llimit ();

  /**
       * @if jp
       * 関節速度最大値
       * @endif
       */
  double[] uvlimit ();

  /**
       * @if jp
       * 関節速度最小値
       * @endif
       */
  double[] lvlimit ();

  /**
       * @if jp
       * ロータ慣性
       * @endif
       */
  double rotorInertia ();

  /**
       * @if jp
       * ロータ抵抗
       * @endif
       */
  double rotorResistor ();

  /**
       * @if jp
       * ギア比
       * @endif
       */
  double gearRatio ();

  /**
       * @if jp
       * ギア効率
       * @endif
       */
  double gearEfficiency ();

  /**
       * @if jp
       * トルク定数
       * @endif
       */
  double torqueConst ();

  /**
       * @if jp
       * エンコーダパルス
       * @endif
       */
  double encoderPulse ();

  /**
       * @if jp
       * 等価集中
       * @endif
       */
  double equivalentInertia ();

  /**
       * @if jp
       * バウンダリボックス中心
       * @endif
       */
  double[] bboxCenter ();

  /**
       * @if jp
       * バウンダリボックスサイズ
       * @endif
       */
  double[] bboxSize ();

  /**
       * @if jp
       * モデル名
       * @endif
       */
  String name ();

  /**
       * @if jp
       * Joint 種別
       * @endif
       */
  String jointType ();

  /**
       * @if jp
       * Joint に対してふられたID
       * @endif
       */
  int jointId ();

  /**
       * @if jp
       * Joint の軸
       * @endif
       */
  double[] jointAxis ();

  /**
       * @if jp
       * 親リンク
       * @endif
       */
  int mother ();

  /**
       * @if jp
       * 兄弟リンク
       * @endif
       */
  int sister ();

  /**
       * @if jp
       * 子リンク
       * @endif
       */
  int daughter ();

  // index
  jp.go.aist.hrp.simulator.SensorInfo[] sensors ();

  /**
       * @if jp
       * 幾何モデルのトライアングルメッシュを読み込みます。
       * @param start 開始のメッシュ番号
       * @param count 何個メッシュを読み込むか
       * @return トライアングルメッシュ集合
       *
       * 9個の double 値でひとつの三角形を示します。
       * @else
       * Read Triangles
       * @param     jointName   joint name
       * @param     start
       * @param     count       Number of triangles to read
       * @return    group of triangles
       *            every 9 double values represent one triangle
       * @endif
       */
  double[] readTriangles (int start, int count);
} // interface LinkInfoOperations
