package jp.go.aist.hrp.simulator;


/**
* jp/go/aist/hrp/simulator/ModelLoaderOperations.java .
* IDL-to-Java コンパイラ (ポータブル), バージョン "3.1" で生成
* 生成元: C:/Users/ishimura/workspaces/ai_project/OpenHRP3Client/src/idl/OpenHRP/ModelLoader.idl
* 2009年2月18日 12時58分37秒 JST
*/


/**
   * @if jp
   * @brief ModelLoader インタフェース定義です。
   *
   * テキスト記述されたモデル情報を読み込み、オブジェクトとして提供します。
   * クライアントからは load() して CharacterInfo を取得し、それを DynamicsSimulator等に登録します。
   * @endif
   * @author  Keisuke Saito, KernelInc
   */
public interface ModelLoaderOperations  extends jp.go.aist.hrp.simulator.ServerObjectOperations
{

  /**
       * @if jp
       * ファイルからロードします。
       * @param   url                 ファイルのURL
       * @return  情報を保持したオブジェクト
       * @endif
       */
  jp.go.aist.hrp.simulator.CharacterInfo loadURL (String url) throws jp.go.aist.hrp.simulator.ModelLoaderPackage.ModelLoaderException;

  /**
       * @if jp
       * ファイルからキャッシュを使わずにロード します。
       * @param   url                 ファイルのURL
       * @return  情報を保持したオブジェクト
       * @endif
       */
  jp.go.aist.hrp.simulator.CharacterInfo reloadURL (String url) throws jp.go.aist.hrp.simulator.ModelLoaderPackage.ModelLoaderException;

  /**
       * @if jp
       * キャッシュをクリアします。
       * @endif
       */
  void clearData ();
} // interface ModelLoaderOperations
