package jp.go.aist.hrp.simulator;


/**
* jp/go/aist/hrp/simulator/OnlineViewerPOA.java .
* IDL-to-Java コンパイラ (ポータブル), バージョン "3.1" で生成
* 生成元: C:/Users/ishimura/workspaces/ai_project/OpenHRP3Client/src/idl/OpenHRP/OnlineViewer.idl
* 2009年2月18日 12時58分37秒 JST
*/


/**
   * @if jp
   * OnlineViewer インターフェース
   *
   * GrxUI の 3DView をクライアントプログラムから表示させる際に使用します。
   *
   * load() で読み込んだモデルに対して update() で情報を与えることでアニメーションします。
   *
   * また、 update() を使用すると情報は記録され、後で再生することもできます。
   */
public abstract class OnlineViewerPOA extends org.omg.PortableServer.Servant
 implements jp.go.aist.hrp.simulator.OnlineViewerOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("update", new java.lang.Integer (0));
    _methods.put ("load", new java.lang.Integer (1));
    _methods.put ("clearLog", new java.lang.Integer (2));
    _methods.put ("clearData", new java.lang.Integer (3));
    _methods.put ("drawScene", new java.lang.Integer (4));
    _methods.put ("setLineWidth", new java.lang.Integer (5));
    _methods.put ("setLineScale", new java.lang.Integer (6));
    _methods.put ("getPosture", new java.lang.Integer (7));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
       * @if jp
       * 表示内容を更新します
       *
       * 内容は記録され、後で再生し直すことができます。
       * @param state 更新する表示内容の情報
       * @else
       * Update Display
       * @endif
       */
       case 0:  // OpenHRP/OnlineViewer/update
       {
         jp.go.aist.hrp.simulator.WorldState state = jp.go.aist.hrp.simulator.WorldStateHelper.read (in);
         this.update (state);
         out = $rh.createReply();
         break;
       }


  /**
       * @if jp
       * モデルの読み込みを行います。
       * @param name モデル名
       * @param url モデルファイルURL
       * @endif 
       */
       case 1:  // OpenHRP/OnlineViewer/load
       {
         String name = in.read_string ();
         String url = in.read_string ();
         this.load (name, url);
         out = $rh.createReply();
         break;
       }


  /**
       * @if jp
       * 記録されたいままでの更新をクリアします。
       * @endif
       */
       case 2:  // OpenHRP/OnlineViewer/clearLog
       {
         this.clearLog ();
         out = $rh.createReply();
         break;
       }


  /**
       * @if jp
       * データをクリアします。
       * @endif
       */
       case 3:  // OpenHRP/OnlineViewer/clearData
       {
         this.clearData ();
         out = $rh.createReply();
         break;
       }


  /**
       * @if jp
       * 表示内容を更新します。 update() とは違い、更新内容を記録しません。
       * @param state 更新する表示内容の情報
       * @else
       * state display without recording  '03 Apr.4  s.kajita
       * @endif
       */
       case 4:  // OpenHRP/OnlineViewer/drawScene
       {
         jp.go.aist.hrp.simulator.WorldState state = jp.go.aist.hrp.simulator.WorldStateHelper.read (in);
         this.drawScene (state);
         out = $rh.createReply();
         break;
       }


  /**
       * @if jp
       * 線の幅を設定します。
       * @endif
       */
       case 5:  // OpenHRP/OnlineViewer/setLineWidth
       {
         float width = in.read_float ();
         this.setLineWidth (width);
         out = $rh.createReply();
         break;
       }


  /**
       * @if jp
       * スケールを設定します。
       * @endif
       */
       case 6:  // OpenHRP/OnlineViewer/setLineScale
       {
         float scale = in.read_float ();
         this.setLineScale (scale);
         out = $rh.createReply();
         break;
       }


  /**
       * @if jp
       * 
       * @endif
       */
       case 7:  // OpenHRP/OnlineViewer/getPosture
       {
         String robotId = in.read_string ();
         jp.go.aist.hrp.simulator.DblSequenceHolder posture = new jp.go.aist.hrp.simulator.DblSequenceHolder ();
         boolean $result = false;
         $result = this.getPosture (robotId, posture);
         out = $rh.createReply();
         out.write_boolean ($result);
         jp.go.aist.hrp.simulator.DblSequenceHelper.write (out, posture.value);
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:OpenHRP/OnlineViewer:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public OnlineViewer _this() 
  {
    return OnlineViewerHelper.narrow(
    super._this_object());
  }

  public OnlineViewer _this(org.omg.CORBA.ORB orb) 
  {
    return OnlineViewerHelper.narrow(
    super._this_object(orb));
  }


} // class OnlineViewerPOA
